//
//  Test_FrameworkAppDelegate.m
//
//  Created by Joe Hogue and Paul Zirkle
//

#import "Test_FrameworkAppDelegate.h"
#import "gsMain.h"
#import "ExampleViewController.h"
#define IPHONE_WIDTH 320
#define IPHONE_HEIGHT 480

@implementation Test_FrameworkAppDelegate

@synthesize window;
@synthesize viewController;

- (void) applicationDidFinishLaunching:(UIApplication *)application 
{
	//set up main loop
	[NSTimer scheduledTimerWithTimeInterval:0.033 target:self selector:@selector(gameLoop:) userInfo:nil repeats:NO];
	
	//create instance of first GameState
	[self doStateChange:[gsMain class]];
}

- (void) gameLoop:(id) sender 
{
	double currTime = [[NSDate date] timeIntervalSince1970];
	m_FPS_framesThisSecond++;
	float timeThisSecond = currTime - m_FPS_lastSecondStart;
	if( timeThisSecond > 1.0f ) {
		m_FPS = m_FPS_framesThisSecond;
		m_FPS_framesThisSecond = 0;
		m_FPS_lastSecondStart = currTime;
	}
	[((GameState*)viewController.view) Update];
	[((GameState*)viewController.view) Render];
	[NSTimer scheduledTimerWithTimeInterval:0.033 target:self selector:@selector(gameLoop:) userInfo:nil repeats:NO];
}

- (void) doStateChange: (Class) state
{
	if ( viewController.view != nil ) {
		//remove the view from the window's subviews.
		[viewController.view removeFromSuperview];
		[viewController.view release]; //release game state.
	}
	
	viewController.view = [[state alloc] initWithFrame:CGRectMake(0, 0, IPHONE_WIDTH, IPHONE_HEIGHT) andManager:self];
	
	//set our view as visible.
	[window addSubview:viewController.view];
	[window makeKeyAndVisible];
}

- (int) getFramesPerSecond{
	return m_FPS;
}

- (void)dealloc {
    [viewController release];
    [window release];
    [super dealloc];
}

@end
